
; sequenceur radio a base de 12f675 
    ;a dure variable
; --par F5UBZ -- 03/2020 -- 
; version relais antenne monostable
 #include "p12f675.inc"

 __CONFIG _FOSC_INTRCIO & _WDTE_OFF & _PWRTE_OFF & _MCLRE_OFF & _BOREN_ON & _CP_OFF & _CPD_OFF

		  
ptt             equ     0x03 ; entre PTT // mise a la masse 
tx_on	        equ	0x04 ; sortie  alimentation chaine tx (PA...)
relais_antenne	equ	0x02 ; sortie relais antenne		
rx_on           equ     0x05 ; sortie alimentaion chaine Rx (preampli ....)
analog_in       equ     0x00 ; entre analogique     

cnt	        equ 40h   ;
count           equ 41h   ;
temp            equ 42h   ;	   

                org 0
		goto start 	    ; vecteur de reset 
		
start           bcf STATUS,RP0
		clrf GPIO
		
		bsf STATUS,RP0
		movlw b'01010001'  ; GPIO0 = entre analogique
		movwf ANSEL        ; Fosc /16
		movlw b'00001011'  ; GP1,GPIO3 = entre digitale
		movwf TRISIO       ; GPIO2,GPIO3,GPIO4,GPIO5 = output digital
                movlw b'00000010'
                movwf WPU          ;pull up sur GPIO 1
                movlw b'01111111'
                movwf OPTION_REG   ;pull up individuel autoris  
		bcf STATUS,RP0

		movlw d'7'
		movwf CMCON    ;comparateur OFF		

    	        bcf GPIO,tx_on
		bcf GPIO,relais_antenne
		bsf GPIO,rx_on	  ; initialisation des 3 sorties au depart 
		
		movlw b'0000001'  ; demarrage  du
		movwf ADCON0      ; convertisseur A/N
		call wait_2ms     ;	
		
test_polar_ptt	btfss GPIO,1
		goto loop_reverse  ; test polarit systeme PTT				
			
		
loop_normal     btfsc GPIO,ptt	  ; attente mise a la masse	
		goto $-1          ; du PTT
		bcf GPIO,rx_on
		call wait_an0_delay			
		bsf GPIO,relais_antenne
		call wait_an0_delay		
		bsf GPIO,tx_on 
		btfss GPIO,ptt   ; attente relache PTT
		goto $-1
		bcf GPIO,tx_on
		call wait_an0_delay
		bcf GPIO,relais_antenne
		call wait_an0_delay		
		bsf GPIO,rx_on
		call wait_an0_delay
		goto test_polar_ptt
		
loop_reverse    btfss GPIO,ptt	  ; attente PTT au +5v
		goto $-1          ; du PTT
		bcf GPIO,rx_on
		call wait_an0_delay			
		bsf GPIO,relais_antenne
		call wait_an0_delay		
		bsf GPIO,tx_on 
		btfsc GPIO,ptt   ; attente relache PTT
		goto $-1
		bcf GPIO,tx_on
		call wait_an0_delay
		bcf GPIO,relais_antenne
		call wait_an0_delay		
		bsf GPIO,rx_on
		call wait_an0_delay
		goto test_polar_ptt		
		
wait_an0_delay 	bsf ADCON0,GO	  ; fonction
                btfsc ADCON0,GO   ; temporisation =
	        goto $-1          ; delais variable en 
		movf ADRESH,W     ; multiple de 2ms
		movwf cnt         ; donne par la valeur
		call wait_2ms     ; issu du convertisseur
		decfsz cnt,F      ; A/N : on ne tient comte
                goto $-2          ; que de 8 bits soit 512ms maxi
         	return 	
		
wait_2ms        movlw	D'4'	 ; fonction delais 2ms 
                movwf   count    ; a quelques s pres (pas critique)
outer_loop                        
	        movlw	H'A4'		
	        movwf	temp
inner_loop
	        decfsz	temp,f		
	        goto	inner_loop				
	        decfsz	count,f		
	        goto	outer_loop				
	        return			

		
		END
		
